"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findClaimStatusKey = exports.findDistributorKey = void 0;
const anchor_1 = require("@project-serum/anchor");
const web3_js_1 = require("@solana/web3.js");
const constants_1 = require("./constants");
const findDistributorKey = async (base) => {
    return await web3_js_1.PublicKey.findProgramAddress([anchor_1.utils.bytes.utf8.encode("MerkleDistributor"), base.toBytes()], constants_1.PROGRAM_ID);
};
exports.findDistributorKey = findDistributorKey;
const findClaimStatusKey = async (index, distributor) => {
    return await web3_js_1.PublicKey.findProgramAddress([
        anchor_1.utils.bytes.utf8.encode("ClaimStatus"),
        index.toArrayLike(Buffer, "le", 8),
        distributor.toBytes(),
    ], constants_1.PROGRAM_ID);
};
exports.findClaimStatusKey = findClaimStatusKey;
//# sourceMappingURL=pda.js.map