import type { AugmentedProvider, Provider } from "@saberhq/solana-contrib";
import type { PublicKey, Signer } from "@solana/web3.js";
import type { CreateDistributorArgs, MerkleDistributorProgram, PendingDistributor } from "./types";
import { MerkleDistributorWrapper } from "./wrapper";
export declare class MerkleDistributorSDK {
    readonly provider: AugmentedProvider;
    readonly program: MerkleDistributorProgram;
    constructor(provider: AugmentedProvider, program: MerkleDistributorProgram);
    withSigner(signer: Signer): MerkleDistributorSDK;
    /**
     * Loads the SDK.
     * @returns {MerkleDistributorSDK}
     */
    static load({ provider, }: {
        provider: Provider;
    }): MerkleDistributorSDK;
    /**
     * Load an existing merkle distributor.
     * @returns {MerkleDistributorWrapper}
     */
    loadDistributor(key: PublicKey): Promise<MerkleDistributorWrapper>;
    /**
     * Create a merkle distributor.
     * @returns {PendingDistributor}
     */
    createDistributor(args: Omit<CreateDistributorArgs, "sdk">): Promise<PendingDistributor>;
}
//# sourceMappingURL=sdk.d.ts.map