/// <reference types="node" />
import type { PublicKey } from "@solana/web3.js";
import type BN from "bn.js";
export declare class BalanceTree {
    private readonly _tree;
    constructor(balances: {
        account: PublicKey;
        amount: BN;
    }[]);
    static verifyProof(index: number, account: PublicKey, amount: BN, proof: Buffer[], root: Buffer): boolean;
    static toNode(index: number, account: PublicKey, amount: BN): Buffer;
    getHexRoot(): string;
    getHexProof(index: number, account: PublicKey, amount: BN): string[];
    getRoot(): Buffer;
    getProof(index: number, account: PublicKey, amount: BN): Buffer[];
}
//# sourceMappingURL=balance-tree.d.ts.map