/// <reference types="@solana/spl-token" />
import { TransactionEnvelope } from "@saberhq/solana-contrib";
import type { u64 } from "@saberhq/token-utils";
import type { PublicKey, TransactionInstruction } from "@solana/web3.js";
import type { MerkleDistributorSDK } from "./sdk";
import type { ClaimArgs, ClaimStatus, CreateDistributorArgs, DistributorData, MerkleDistributorProgram, PendingDistributor } from "./types";
export declare class MerkleDistributorWrapper {
    readonly sdk: MerkleDistributorSDK;
    readonly program: MerkleDistributorProgram;
    readonly key: PublicKey;
    readonly distributorATA: PublicKey;
    data: DistributorData;
    constructor(sdk: MerkleDistributorSDK, key: PublicKey, distributorATA: PublicKey, data: DistributorData);
    static load(sdk: MerkleDistributorSDK, key: PublicKey): Promise<MerkleDistributorWrapper>;
    static createDistributor(args: CreateDistributorArgs): Promise<PendingDistributor>;
    claimIX(args: ClaimArgs, payer: PublicKey): Promise<TransactionInstruction>;
    claim(args: ClaimArgs): Promise<TransactionEnvelope>;
    getClaimStatus(index: u64): Promise<ClaimStatus>;
    reload(): Promise<void>;
}
//# sourceMappingURL=wrapper.d.ts.map